import java.util.*;
import java.io.*;

public class Wordix { 
    static class Word { 
        String eng;
        int    count;
    };
    
    static final int FREQUENCY = 0;
    static final int MAX_LENGTH = 6;

    public static void main(String[] args) throws Exception {
	BufferedReader in = new BufferedReader(new FileReader("Mueller7GPL.win"));
	String line;
	TreeMap hash = new TreeMap();
      nextLine:
	while ((line = in.readLine()) != null) { 
	    int i = line.indexOf(' ');
	    if (i > 1 && i <= MAX_LENGTH) {
                for (int j = 0; j < i; j++) { 
                    char ch = line.charAt(j);
                    if (!(ch >= 'a' && ch <= 'z') && !(ch >= 'A' && ch <= 'Z')) {
                        continue nextLine;
                    }
                }    
                String w = line.substring(0, i).toUpperCase();
                Word word = new Word();                
                word.eng = w;
                hash.put(w, word);
	    }
	}
        if (FREQUENCY != 0) { 
            byte[] buf = new byte[1025*1024];
            int rc;
            FileInputStream fs = new FileInputStream("samples.txt");
            while ((rc = fs.read(buf)) > 0) { 
                for (int i = 0; i < rc; i++) { 
                    int j = i;
                    char ch;
                    while (j < rc && (((ch = (char)buf[j]) >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'))) {
                        j += 1;
                    }
                    if (j > i) { 
                        String key = new String(buf, i, j-i).toUpperCase();
                        Word word = (Word)hash.get(key);
                        if (word != null) { 
                            word.count += 1;
                        }
                        i = j;
                    }
                }
            }
        }
	FileOutputStream out = new FileOutputStream("wordix-eng.dic");
	Iterator iterator = hash.values().iterator();
	int n = 0;
        int totalSize = 0;
        String prevWord = null;
	while (iterator.hasNext()) { 
	    Word word = (Word)iterator.next();
	    if (word.count >= FREQUENCY && (prevWord == null || !word.eng.startsWith(prevWord))) { 
		StringBuffer sb = new StringBuffer();
                prevWord = word.eng;
		sb.append(word.eng);
		sb.append('\n');
                byte[] bytes = sb.toString().getBytes();
                totalSize += bytes.length;
		n += 1;
		out.write(bytes);
	    }
	}
	out.close();
	System.out.println("Words " + n + ", size " + totalSize);
    }
}